stages:
  - pre-commit
  - test
  - build
  - staging
  - integration
  - deploy


include:
  - template: Jobs/SAST.gitlab-ci.yml
  - template: Jobs/SAST-IaC.gitlab-ci.yml
  - template: Security/Secret-Detection.gitlab-ci.yml

.default: &default
  image: python:3.10
  cache:
    paths:
      - .cache/pip
  before_script:
    - python -V
    - pip install -U pip

variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

pre-commit:
  <<: *default
  stage: pre-commit
  script:
    - pip install pre-commit
    - pre-commit run --all-files

dummy test:
  <<: *default
  stage: test
  image: python:3.11
  script:
    - ": This is a dummy test and does nothing"

build images:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [ "" ]
  before_script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
  script:
    - /kaniko/executor --context $CI_PROJECT_DIR        --dockerfile $CI_PROJECT_DIR/Dockerfile    --cache=true --destination ${CI_REGISTRY_IMAGE}:latest    --destination ${CI_REGISTRY_IMAGE}:$CI_COMMIT_SHORT_SHA    --destination ${CI_REGISTRY_IMAGE}:$CI_COMMIT_TAG --build-arg CI_COMMIT_TAG=$CI_COMMIT_TAG --build-arg CI_COMMIT_TIMESTAMP=$CI_COMMIT_TIMESTAMP
  rules:
    - if: $CI_COMMIT_TAG
      when: always

.deploycommon: &deploycommon
  image:
    name: alpine/k8s:1.27.4
    entrypoint: [ "" ]
  before_script:
    - kubectl config use-context flexitricity/it/infrastructure/gitlab-agents:paz-k8s01-agent
  rules:
    - if: $CI_COMMIT_TAG
      when: manual

.deplystart: &deploystart
  <<: *deploycommon
  script:
    - helm version
    - |
      helm --debug upgrade --install --namespace $DEPLOYNAME --create-namespace --wait --timeout 3600s \
      --set tag=$CI_COMMIT_TAG \
      --set appname=$DEPLOYNAME --set reg.secret=$K8SREG \
      --set cert=$CERT --set fqdn=$FQDN \
      $DEPLOYNAME ./azure

.deploystop: &deploystop
  <<: *deploycommon
  script:
    - helm version
    - helm uninstall --wait --timeout 3600s --namespace $DEPLOYNAME $DEPLOYNAME


start staging:
  stage: staging
  environment:
    name: staging
    url: https://solarapi.flex.paz
    on_stop: stop staging
    auto_stop_in: 2 week
  variables:
    FQDN: solarapi.flex.paz
    CERT: pazstar
    DEPLOYNAME: paz-solarapi
    KUBE_CONFIG: flexitricity/it/infrastructure/gitlab-agents:paz-k8s01-agent
  <<: *deploystart

stop staging:
  stage: staging
  variables:
    DEPLOYNAME: paz-solarapi
    KUBE_CONFIG: flexitricity/it/infrastructure/gitlab-agents:paz-k8s01-agent
  environment:
    name: staging
    action: stop
  <<: *deploystop
